//Metal Sonic 3.0 in SRB2 by Isaque, CloneFighter, RubyTheMii and Teorati
freeslot("S_PLAY_NEGARISE", "S_PLAY_NEGAWAIT", "S_PLAY_NEGAFALL")
states[S_PLAY_NEGARISE] = {SPR_PLAY, SPR2_SPNG|A, 2, nil, 0, 0, S_PLAY_NEGARISE}
states[S_PLAY_NEGAWAIT] = {SPR_PLAY, SPR2_WAIT|A, 2, nil, 0, 0, S_PLAY_NEGAWAIT}
states[S_PLAY_NEGAFALL] = {SPR_PLAY, SPR2_FALL|A, 2, nil, 0, 0, S_PLAY_NEGAFALL}

//Air Burst and modified Hover.
addHook("AbilitySpecial", function(player)
	if player.mo and player.mo.skin == "metalnega"
		if (player.pflags & PF_JUMPED) and not (player.pflags & PF_THOKKED)
			player.pflags = $|PF_THOKKED
			P_Thrust(player.mo, player.mo.angle, 40*FRACUNIT)
			S_StartSound(player.mo, sfx_thok)
			S_StartSound(player.mo, sfx_cdfm62)
			local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
			thok.state = S_FACESTABBERSPEAR
			thok.angle = player.drawangle+ANGLE_90
			thok.scale = player.mo.scale
			thok.fuse = 5
			thok.frame = $ & ~FF_TRANSMASK | TR_TRANS30
			thok.tics = 20
			thok.blendmode = AST_ADD
			thok.destscale = $*2
			thok.color = SKINCOLOR_PASTEL
			thok.colorized = true
		end
	end
end)

local function MetalSonic30(mo, trailmo, freq)
    if not mo.prevz or not mo.prevleveltime or (mo.prevleveltime ~= leveltime - 1) then
       mo.prevz = mo.z
    end
    local rmomz = mo.z - mo.prevz
    mo.prevz = mo.z
    mo.prevleveltime = leveltime
    local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), rmomz)
    local dist = (mospeed/freq)
    for i = dist, 1, -1 do
        local spawnedmo = P_SpawnMobjFromMobj(mo, (mo.momx/dist)*i, (mo.momy/dist)*i, (rmomz/dist)*i, trailmo)
        spawnedmo.color = SKINCOLOR_PURPLE
        spawnedmo.blendmode = AST_ADD
		spawnedmo.frame = FF_TRANS50
		spawnedmo.destscale = 0
		spawnedmo.fuse = 4
    end
end

-- A custom color script for singleplayer XMomentum. ~RubyTheMii
addHook("PlayerThink", function(player)
   if player.mo and player.mo.skin == "metalnega" and not (multiplayer or netgame)
      if player.isxmomentum or player.xmomtoggledoff == false
	     and not (player.powers[pw_super] or player.powers[pw_shield] == SH_FIREFLOWER)
		 player.mo.color = SKINCOLOR_COPYBOT
	  end
   end
end)

//Had to try to recreate the vanilla hover ability for this.
//Worked out pretty well, though!
addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "metalnega"
	   if player.isxmomentum or player.xmomtoggledoff == false
	      if player.pflags & PF_THOKKED
	         player.spcanflip = false
	      else
	         player.spcanflip = true
	      end
	   end
	   if not (player.exiting or P_PlayerInPain(player) or player.playerstate == PST_DEAD or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL)
	   if player.pflags & PF_THOKKED
	      if player.pflags & PF_JUMPDOWN
		  if (player.dashmode >= 3*TICRATE)
			 player.mo.state = S_PLAY_DASH
		  else
		     if player.speed >= 24*FRACUNIT
			    player.mo.state = S_PLAY_FLOAT_RUN
		     else
			    player.mo.state = S_PLAY_FLOAT
		     end
		  end
		  P_SetObjectMomZ(player.mo, 0, false)
		  else 
		  if not (player.powers[pw_carry] or player.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectOnGround(player.mo) or player.powers[pw_justsprung] or player.mo.eflags & MFE_SPRUNG)
			 player.mo.state = S_PLAY_NEGAFALL
		  end
		  end
	   end
	   end
	end
	if player.mo and player.mo.skin == "metalnega"
		if player.dashmode >= 3*TICRATE
			local metalnega_aura = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
			metalnega_aura.color = SKINCOLOR_PASTEL
			metalnega_aura.colorized = true
			metalnega_aura.blendmode = AST_ADD
			local metalnegaelectric = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
			metalnegaelectric.color = SKINCOLOR_PASTEL
			metalnegaelectric.colorized = true
			metalnegaelectric.blendmode = AST_ADD
			metalnegaelectric.state = S_WATERZAP
			MetalSonic30(player.mo, MT_THOK, 4*FRACUNIT)
			if (leveltime % 24 == 0)
				local thok2 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
				thok2.state = S_FACESTABBERSPEAR
				thok2.angle = player.drawangle+ANGLE_90
				thok2.scale = player.mo.scale/2+FRACUNIT/4
				thok2.fuse = 8
				thok2.color = SKINCOLOR_PURPLE
				thok2.colorized = true
				thok2.blendmode = AST_ADD
			end
		end
		if player.mo.eflags & MFE_UNDERWATER
			player.powers[pw_underwater] = -1
		end
		if player.dashmode >= 3*TICRATE and (player.pflags & PF_THOKKED and player.pflags & PF_JUMPDOWN)
		   player.dashmode = 4*TICRATE
		end
		-- Something extra for XMomentum.
		if player.isxmomentum or player.xmomtoggledoff == false
		   if player.mo.state == S_PLAY_FACEPLANT
		      if S_SoundPlaying(player.mo, sfx_kc46)
			     S_StartSound(player.mo, sfx_fizzle)
				 S_StopSoundByID(player.mo, sfx_kc46)
			  end
		      if P_RandomChance(FRACUNIT/50)
			     S_StartSound(player.mo, sfx_s3k5c)
				 player.mo.colorized = true
				 player.mo.color = SKINCOLOR_WHITE
				 local spark = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-30, 30)*FRACUNIT, P_RandomRange(-30, 30)*FRACUNIT, P_RandomRange(0, 12)*FRACUNIT, MT_PARTICLE)
				 spark.state = S_WATERZAP
				 spark.tics = 5
			  else
			     player.mo.colorized = false
				 player.mo.color = SKINCOLOR_COPYBOT
			  end
		   end
	    end
	end
end)

addHook("PlayerCanDamage", function(player)
   if player.mo and player.mo.skin == "metalnega"
      if player.pflags & PF_THOKKED and player.dashmode < 3*TICRATE then return false; end
   end
end)

//Metal Sonic 3.0 Wait animation by Clone Fighter (temp)
freeslot("S_PARTICLE_MS30UP", "SPR_30PT")
states[S_PARTICLE_MS30UP] = {
    sprite = SPR_30PT,
    frame = FF_FULLBRIGHT|FF_ANIMATE|A,
    tics = 10,
    var1 = 3,
    var2 = 2,
    nextstate = S_NULL
}

addHook("PlayerThink", function(player)
    if not player.mo or not player.mo.valid or player.mo.skin != "metalnega" then return end
    
    if player.mo.state == S_PLAY_WAIT then
        player.waiting = $ or 1
    end
    
    if player.waiting then
        player.mo.jetfume = $ or P_SpawnMobjFromMobj(player.mo, -16*cos(player.drawangle), -16*sin(player.drawangle), 2*player.mo.height/5, MT_METALJETFUME)
        player.mo.jetfume.state = (player.waiting <= 2) and S_JETFUMEFLASH or S_JETFUME1
        player.mo.jetfume.frame = (player.waiting == 1) and D or (player.waiting == 2) and E
        or (player.waiting%3 == 0) and C or (player.waiting%3 == 2) and B or A
        player.mo.jetfume.scale = (player.waiting <= 2) and FRACUNIT or 2*FRACUNIT/5
        P_TeleportMove(player.mo.jetfume, player.mo.x-16*cos(player.drawangle), player.mo.y-16*sin(player.drawangle), player.mo.z+2*player.mo.height/5)
        
        if player.waiting < 15 then
            if player.waiting == 1 then S_StartSound(player.mo, sfx_beflap) end
            player.drawangle = player.mo.angle+FixedAngle(ease.outsine(player.waiting*FRACUNIT/14, 0, 360*FRACUNIT))
            player.mo.flags = $|MF_NOGRAVITY
            P_SetObjectMomZ(player.mo, ease.outsine(player.waiting*FRACUNIT/14, 10*FRACUNIT, 0))
            player.mo.state = S_PLAY_NEGARISE
            
            if leveltime&1 then
                local a = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-32,32)*FRACUNIT, P_RandomRange(-32,32)*FRACUNIT, P_RandomRange(-10,56)*FRACUNIT, MT_PARTICLE)
                a.state = S_PARTICLE_MS30UP
                P_SetObjectMomZ(a, 5*FRACUNIT)
                a.color = SKINCOLOR_RUBY
            end
            
            if player.waiting == 14 then
                player.startz = player.mo.z
            end
        else
            if player.mo.state != S_PLAY_NEGAWAIT then player.mo.state = S_PLAY_NEGAWAIT end
            player.mo.z = 3*sin(FixedAngle(ease.linear(player.waiting*FRACUNIT/80, 0, 360*FRACUNIT)))+player.startz
            
            local a = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-16,16)*FRACUNIT, P_RandomRange(-16,16)*FRACUNIT, P_RandomRange(-5,40)*FRACUNIT, MT_PARTICLE)
            a.state = S_WATERZAP
        end
        player.mo.momx,player.mo.momy = 0,0
        
        player.waiting = $+1
        
        if player.cmd.sidemove or player.cmd.forwardmove or (player.cmd.buttons & (BT_JUMP|BT_SPIN)) then
            player.waiting = 0; player.mo.state = S_PLAY_NEGAFALL
            player.mo.flags = $ & ~MF_NOGRAVITY
            P_RemoveMobj(player.mo.jetfume)
            player.mo.jetfume = nil
        end
    end
end)